## python-uflash 1.2.4+dfsg

=== Makefile ===
XARGS := xargs -0 $(shell test $$(uname) = Linux && echo -r)
GREP_T_FLAG := $(shell test $$(uname) = Linux && echo -T)

all:
	@echo "\nThere is no default Makefile target right now. Try:\n"
	@echo "make clean - reset the project and remove auto-generated assets."
	@echo "make pyflakes - run the PyFlakes code checker."
	@echo "make pep8 - run the PEP8 style checker."
	@echo "make test - run the test suite."
	@echo "make coverage - view a report on test coverage."
	@echo "make check - run all the checkers and tests."
	@echo "make package - create a deployable package for the project."
	@echo "make publish - publish the project to PyPI."
	@echo "make docs - run sphinx to create project documentation.\n"

clean:
	rm -rf build
	rm -rf dist
	rm -rf uflash.egg-info
	rm -rf .coverage
	rm -rf .tox
	rm -rf docs/_build
	find . \( -name '*.py[co]' -o -name dropin.cache \) -print0 | $(XARGS) rm
	find . \( -name '*.bak' -o -name dropin.cache \) -print0 | $(XARGS) rm
	find . \( -name '*.tgz' -o -name dropin.cache \) -print0 | $(XARGS) rm

pyflakes:
	find . \( -name _build -o -name var -o -path ./docs \) -type d -prune -o -name '*.py' -print0 | $(XARGS) pyflakes

pep8: clean
	find . \( -name _build -o -name var \) -type d -prune -o -name '*.py' -print0 | $(XARGS) -n 1 pycodestyle --repeat --exclude=build/*,docs/* --ignore=E731,E402,W504

test: clean
	py.test

coverage: clean
	py.test --cov-report term-missing --cov=uflash tests/

check: clean pep8 pyflakes coverage

package: check
	python setup.py sdist

publish: check
	@echo "\nChecks pass, good to publish..."
	python setup.py sdist upload

docs: clean
	$(MAKE) -C docs html
	@echo "\nDocumentation can be found here:"
	@echo file://`pwd`/docs/_build/html/index.html
	@echo "\n"

=== requirements.txt ===
pytest
pycodestyle
pyflakes
coverage
sphinx
pytest-cov
nudatus>=0.0.2 

# Mock is bundled as part of unittest since Python 3.3
# mock_open can't read binary data in <= 3.4.2
mock ; python_version == '2.7' or python_version == '3.4'

=== docs/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# User-friendly check for sphinx-build
ifeq ($(shell which $(SPHINXBUILD) >/dev/null 2>&1; echo $$?), 1)
$(error The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don't have Sphinx installed, grab it from http://sphinx-doc.org/)
endif

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest coverage gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  applehelp  to make an Apple Help Book"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"
	@echo "  coverage   to run coverage check of the documentation (if enabled)"

clean:
	rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/uFlash.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/uFlash.qhc"

applehelp:
	$(SPHINXBUILD) -b applehelp $(ALLSPHINXOPTS) $(BUILDDIR)/applehelp
	@echo
	@echo "Build finished. The help book is in $(BUILDDIR)/applehelp."
	@echo "N.B. You won't be able to view it unless you put it in" \
	      "~/Library/Documentation/Help or install it in your application" \
	      "bundle."

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/uFlash"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/uFlash"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

coverage:
	$(SPHINXBUILD) -b coverage $(ALLSPHINXOPTS) $(BUILDDIR)/coverage
	@echo "Testing of coverage in the sources finished, look at the " \
	      "results in $(BUILDDIR)/coverage/python.txt."

xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

=== debian/changelog ===
python-uflash (1.2.4+dfsg-11) unstable; urgency=medium

  * Team Upload
  * remove depedency on old python3-mock
  * use new dh-sequence-python3

 -- Alexandre Detiste <tchet@debian.org>  Thu, 21 Mar 2024 21:34:12 +0100

python-uflash (1.2.4+dfsg-10) unstable; urgency=medium

  * d/control:
    - Declare compliance with Debian Policy 4.6.2 (no changes)
    - Add (Build-) Depends on mount
  * d/copyright:
    - Bump years of Debian copyright
  * d/lintian-overrides:
    - Refresh mismatched overrides
  * d/rules:
    - Refresh dh_auto_clean override

 -- Nick Morrott <nickm@debian.org>  Fri, 24 Feb 2023 02:59:25 +0000

python-uflash (1.2.4+dfsg-9) unstable; urgency=medium

  * Drop convenience package firmware-microbit-micropython-dl
  * d/control:
    - Update standards version to 4.6.0, no changes needed.
    - Drop unnecessary version constraints
    - Promote firmware-microbit-micropython to (Build-)Depends (Closes: #919752)
  * d/copyright:
    - Refresh years of Debian copyright
    - Use 4-digit years for Debian copyright ranges
  * d/patches:
    - Drop patch disable-tests-requiring-local-runtime
    - Refresh patch use-debian-micropython-runtime-hex
  * d/t/control:
    - Add python3-all to test dependencies
  * d/u/metadata:
    - Remove unknown field Bug-Repository
  * d/watch:
    - Update pattern for GitHub archive URLs

 -- Nick Morrott <nickm@debian.org>  Tue, 15 Feb 2022 11:17:06 +0000

python-uflash (1.2.4+dfsg-8) unstable; urgency=medium

  * d/firmware-microbit-micropython-dl.postinst:
    - Update firmware URL (Closes: #991280)

 -- Nick Morrott <nickm@debian.org>  Fri, 30 Jul 2021 04:26:04 +0100

python-uflash (1.2.4+dfsg-7) unstable; urgency=medium

  * d/python-uflash-doc.links:
    - Add convenience links to python3-uflash package
  * d/salsa-ci.yml:
    - Add Salsa CI pipeline

 -- Nick Morrott <nickm@debian.org>  Sun, 07 Feb 2021 09:27:01 +0000

python-uflash (1.2.4+dfsg-6) unstable; urgency=medium

  * Team upload.
  * No change source-only upload for testing migration.

 -- Boyuan Yang <byang@debian.org>  Wed, 20 Jan 2021 10:08:20 -0500

python-uflash (1.2.4+dfsg-5) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/control:
    - Update Maintainer field with new Debian Python Team contact address.
    - Update Vcs-* fields with new Debian Python Team Salsa layout.

  [ Debian Janitor ]
  * d/u/metadata:
    - Set upstream metadata fields: Bug-Database.
    - Remove obsolete fields Contact, Name (already present in
      machine-readable debian/copyright).

  [ Nick Morrott ]
  * d/control:
    - Declare compliance with Debian Policy 4.5.1
    - Rename -doc package to drop Python version
    - Add firmware-microbit-micropython-dl Enhances python3-uflash dep
  * d/copyright:
    - Refresh years of Debian copyright
  * d/lintian-overrides:
    - Add overrides for odd-mark-in-description
  * d/watch:
    - Migrate to version 4 watch file format

 -- Nick Morrott <nickm@debian.org>  Tue, 05 Jan 2021 01:06:41 +0000

python-uflash (1.2.4+dfsg-4) unstable; urgency=medium

  * d/manpages:
    - Improve formatting of custom manpage

 -- Nick Morrott <nickm@debian.org>  Fri, 31 Jul 2020 19:06:05 +0100

python-uflash (1.2.4+dfsg-3) unstable; urgency=medium

  * d/control:
    - Mark package python3-uflash-doc as M-A: foreign
  * d/manpages:
    - Update authorship

 -- Nick Morrott <nickm@debian.org>  Fri, 31 Jul 2020 15:52:34 +0100

python-uflash (1.2.4+dfsg-2) unstable; urgency=medium

  [ Ondřej Nový ]
  * Use debhelper-compat instead of debian/compat.

  [ Nick Morrott ]
  * d/control:
    - Bump Standards-Version to 4.5.0
    - Bump debhelper-compat level to 13
    - Set Rules-Requires-Root to no
    - Update Uploaders to use my Debian email address
    - Fix typo in dependency for python3-uflash-doc binary package
      (Closes: #962706)
  * d/copyright:
    - Refresh years of Debian copyright
  * d/gbp.conf:
    - Use pristine-tar
  * d/tests:
    - Run autopkgtests against all supported Python versions

 -- Nick Morrott <nickm@debian.org>  Wed, 17 Jun 2020 23:30:03 +0100

python-uflash (1.2.4+dfsg-1) unstable; urgency=medium

  * Initial release. (Closes: #906450)

 -- Nick Morrott <knowledgejunkie@gmail.com>  Sun, 30 Dec 2018 19:02:29 +0100

=== debian/control ===
Source: python-uflash
Section: python
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Nick Morrott <nickm@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-python3,
 firmware-microbit-micropython,
 mount,
 pandoc,
 python3-all,
 python3-coverage,
 python3-nudatus,
 python3-pycodestyle,
 python3-pyflakes,
 python3-pytest,
 python3-pytest-cov,
 python3-setuptools,
 python3-sphinx,
Standards-Version: 4.6.2
Homepage: https://github.com/ntoll/uflash
Vcs-Browser: https://salsa.debian.org/python-team/packages/python-uflash
Vcs-Git: https://salsa.debian.org/python-team/packages/python-uflash.git
Rules-Requires-Root: no

Package: python3-uflash
Architecture: all
Depends:
 firmware-microbit-micropython,
 mount,
 python3,
 python3-nudatus,
 ${misc:Depends},
 ${python3:Depends},
Suggests:
 python-uflash-doc,
Description: module and utility for flashing the BBC micro:bit
 uflash is a utility for flashing the BBC micro:bit with Python scripts
 and the MicroPython runtime.
 .
 It provides two services:
 .
  * a library of functions to programmatically create a hex file and flash
    it onto a BBC micro:bit.
  * a command line utility (uflash) that will flash Python scripts onto
    a BBC micro:bit
 .
 Several essential operations are implemented:
 .
  * encode Python into the hex format
  * embed the resulting hexified Python into the MicroPython runtime hex
  * extract an encoded Python script from a MicroPython hex file
  * discover the connected micro:bit
  * copy the resulting hex onto the micro:bit, thus flashing the device
  * specify the MicroPython runtime hex in which to embed your Python code
 .
 By default, python3-uflash uses the MicroPython runtime for micro:bit
 provided by the firmware-microbit-micropython package and which is
 located at /usr/share/firmware-microbit-micropython/firmware.hex.
 .
 This package provides the Python 3 module.

Package: python-uflash-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
Suggests:
 www-browser,
Enhances: python3-uflash
Breaks: python3-uflash-doc
Replaces: python3-uflash-doc
Description: module and utility for flashing the BBC micro:bit (documentation)
 uflash is a utility for flashing the BBC micro:bit with Python scripts
 and the MicroPython runtime.
 .
 It provides two services:
 .
  * a library of functions to programmatically create a hex file and flash
    it onto a BBC micro:bit.
  * a command line utility (uflash) that will flash Python scripts onto
    a BBC micro:bit
 .
 Several essential operations are implemented:
 .
  * encode Python into the hex format
  * embed the resulting hexified Python into the MicroPython runtime hex
  * extract an encoded Python script from a MicroPython hex file
  * discover the connected micro:bit
  * copy the resulting hex onto the micro:bit, thus flashing the device
  * specify the MicroPython runtime hex in which to embed your Python code
 .
 By default, python3-uflash uses the MicroPython runtime for micro:bit
 provided by the firmware-microbit-micropython package and which is
 located at /usr/share/firmware-microbit-micropython/firmware.hex.
 .
 This package provides the uflash documentation.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DH_ALWAYS_EXCLUDE=__pycache__

export DH_VERBOSE=1
export PYBUILD_VERBOSE=1

export LC_ALL=C.UTF-8

export PYBUILD_NAME=uflash
export PYBUILD_TEST_PYTEST = 1

%:
	dh $@ --with sphinxdoc --buildsystem=pybuild

override_dh_auto_clean:
	dh_auto_clean
	rm -f debian/uflash.1.md
	rm -f debian/uflash.1
	rm -rf docs/html
	rm -rf uflash.egg-info
	rm -rf __pycache__

override_dh_auto_build:
	dh_auto_build
	# build custom manpage
	@echo DEB_VERSION_UPSTREAM $(DEB_VERSION_UPSTREAM)
	sed -e "s/__VERSION__/$(DEB_VERSION_UPSTREAM)/g" \
				< debian/uflash.1.md.in > debian/uflash.1.md
	pandoc debian/uflash.1.md -s -f markdown -t man -o debian/uflash.1
	# build documentation
	PYTHONPATH=. http_proxy='127.0.0.1:9' https_proxy='127.0.0.1:9' python3 -m sphinx -N -bhtml docs/ docs/html

=== debian/watch ===
version=4
opts="dversionmangle=s/@DEB_EXT@//, repacksuffix=+dfsg1, filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" https://github.com/ntoll/uflash/tags .*/archive/refs/tags/v?@ANY_VERSION@@ARCHIVE_EXT@ debian debian/repack.sh
